# Rules ## List routing rules `client.EmailRouting.Rules.List(ctx, params) (*V4PagePaginationArray[EmailRoutingRule], error)` **get** `/zones/{zone_id}/email/routing/rules` Lists existing routing rules. ### Parameters - `params RuleListParams` - `ZoneID param.Field[string]` Path param: Identifier. - `Enabled param.Field[RuleListParamsEnabled]` Query param: Filter by enabled routing rules. - `const RuleListParamsEnabledTrue RuleListParamsEnabled = true` - `const RuleListParamsEnabledFalse RuleListParamsEnabled = false` - `Page param.Field[float64]` Query param: Page number of paginated results. - `PerPage param.Field[float64]` Query param: Maximum number of results per page. ### Returns - `type EmailRoutingRule struct{…}` - `ID string` Routing rule identifier. - `Actions []Action` List actions patterns. - `Type ActionType` Type of supported action. - `const ActionTypeDrop ActionType = "drop"` - `const ActionTypeForward ActionType = "forward"` - `const ActionTypeWorker ActionType = "worker"` - `Value []string` - `Enabled EmailRoutingRuleEnabled` Routing rule status. - `const EmailRoutingRuleEnabledTrue EmailRoutingRuleEnabled = true` - `const EmailRoutingRuleEnabledFalse EmailRoutingRuleEnabled = false` - `Matchers []Matcher` Matching patterns to forward to your actions. - `Type MatcherType` Type of matcher. - `const MatcherTypeAll MatcherType = "all"` - `const MatcherTypeLiteral MatcherType = "literal"` - `Field MatcherField` Field for type matcher. - `const MatcherFieldTo MatcherField = "to"` - `Value string` Value for matcher. - `Name string` Routing rule name. - `Priority float64` Priority of the routing rule. - `Tag string` Routing rule tag. (Deprecated, replaced by routing rule identifier) ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/email_routing" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"), option.WithAPIEmail("user@example.com"), ) page, err := client.EmailRouting.Rules.List(context.TODO(), email_routing.RuleListParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", page) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": [ { "id": "a7e6fb77503c41d8a7f3113c6918f10c", "actions": [ { "type": "forward", "value": [ "destinationaddress@example.net" ] } ], "enabled": true, "matchers": [ { "type": "literal", "field": "to", "value": "test@example.com" } ], "name": "Send to user@example.net rule.", "priority": 0, "tag": "a7e6fb77503c41d8a7f3113c6918f10c" } ], "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 1, "total_pages": 100 } } ``` ## Get routing rule `client.EmailRouting.Rules.Get(ctx, ruleIdentifier, query) (*EmailRoutingRule, error)` **get** `/zones/{zone_id}/email/routing/rules/{rule_identifier}` Get information for a specific routing rule already created. ### Parameters - `ruleIdentifier string` Routing rule identifier. - `query RuleGetParams` - `ZoneID param.Field[string]` Identifier. ### Returns - `type EmailRoutingRule struct{…}` - `ID string` Routing rule identifier. - `Actions []Action` List actions patterns. - `Type ActionType` Type of supported action. - `const ActionTypeDrop ActionType = "drop"` - `const ActionTypeForward ActionType = "forward"` - `const ActionTypeWorker ActionType = "worker"` - `Value []string` - `Enabled EmailRoutingRuleEnabled` Routing rule status. - `const EmailRoutingRuleEnabledTrue EmailRoutingRuleEnabled = true` - `const EmailRoutingRuleEnabledFalse EmailRoutingRuleEnabled = false` - `Matchers []Matcher` Matching patterns to forward to your actions. - `Type MatcherType` Type of matcher. - `const MatcherTypeAll MatcherType = "all"` - `const MatcherTypeLiteral MatcherType = "literal"` - `Field MatcherField` Field for type matcher. - `const MatcherFieldTo MatcherField = "to"` - `Value string` Value for matcher. - `Name string` Routing rule name. - `Priority float64` Priority of the routing rule. - `Tag string` Routing rule tag. (Deprecated, replaced by routing rule identifier) ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/email_routing" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"), option.WithAPIEmail("user@example.com"), ) emailRoutingRule, err := client.EmailRouting.Rules.Get( context.TODO(), "a7e6fb77503c41d8a7f3113c6918f10c", email_routing.RuleGetParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", emailRoutingRule.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "a7e6fb77503c41d8a7f3113c6918f10c", "actions": [ { "type": "forward", "value": [ "destinationaddress@example.net" ] } ], "enabled": true, "matchers": [ { "type": "literal", "field": "to", "value": "test@example.com" } ], "name": "Send to user@example.net rule.", "priority": 0, "tag": "a7e6fb77503c41d8a7f3113c6918f10c" } } ``` ## Create routing rule `client.EmailRouting.Rules.New(ctx, params) (*EmailRoutingRule, error)` **post** `/zones/{zone_id}/email/routing/rules` Rules consist of a set of criteria for matching emails (such as an email being sent to a specific custom email address) plus a set of actions to take on the email (like forwarding it to a specific destination address). ### Parameters - `params RuleNewParams` - `ZoneID param.Field[string]` Path param: Identifier. - `Actions param.Field[[]Action]` Body param: List actions patterns. - `Type ActionType` Type of supported action. - `const ActionTypeDrop ActionType = "drop"` - `const ActionTypeForward ActionType = "forward"` - `const ActionTypeWorker ActionType = "worker"` - `Value []string` - `Matchers param.Field[[]Matcher]` Body param: Matching patterns to forward to your actions. - `Type MatcherType` Type of matcher. - `const MatcherTypeAll MatcherType = "all"` - `const MatcherTypeLiteral MatcherType = "literal"` - `Field MatcherField` Field for type matcher. - `const MatcherFieldTo MatcherField = "to"` - `Value string` Value for matcher. - `Enabled param.Field[RuleNewParamsEnabled]` Body param: Routing rule status. - `const RuleNewParamsEnabledTrue RuleNewParamsEnabled = true` - `const RuleNewParamsEnabledFalse RuleNewParamsEnabled = false` - `Name param.Field[string]` Body param: Routing rule name. - `Priority param.Field[float64]` Body param: Priority of the routing rule. ### Returns - `type EmailRoutingRule struct{…}` - `ID string` Routing rule identifier. - `Actions []Action` List actions patterns. - `Type ActionType` Type of supported action. - `const ActionTypeDrop ActionType = "drop"` - `const ActionTypeForward ActionType = "forward"` - `const ActionTypeWorker ActionType = "worker"` - `Value []string` - `Enabled EmailRoutingRuleEnabled` Routing rule status. - `const EmailRoutingRuleEnabledTrue EmailRoutingRuleEnabled = true` - `const EmailRoutingRuleEnabledFalse EmailRoutingRuleEnabled = false` - `Matchers []Matcher` Matching patterns to forward to your actions. - `Type MatcherType` Type of matcher. - `const MatcherTypeAll MatcherType = "all"` - `const MatcherTypeLiteral MatcherType = "literal"` - `Field MatcherField` Field for type matcher. - `const MatcherFieldTo MatcherField = "to"` - `Value string` Value for matcher. - `Name string` Routing rule name. - `Priority float64` Priority of the routing rule. - `Tag string` Routing rule tag. (Deprecated, replaced by routing rule identifier) ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/email_routing" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"), option.WithAPIEmail("user@example.com"), ) emailRoutingRule, err := client.EmailRouting.Rules.New(context.TODO(), email_routing.RuleNewParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), Actions: cloudflare.F([]email_routing.ActionParam{email_routing.ActionParam{ Type: cloudflare.F(email_routing.ActionTypeForward), }}), Matchers: cloudflare.F([]email_routing.MatcherParam{email_routing.MatcherParam{ Type: cloudflare.F(email_routing.MatcherTypeLiteral), }}), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", emailRoutingRule.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "a7e6fb77503c41d8a7f3113c6918f10c", "actions": [ { "type": "forward", "value": [ "destinationaddress@example.net" ] } ], "enabled": true, "matchers": [ { "type": "literal", "field": "to", "value": "test@example.com" } ], "name": "Send to user@example.net rule.", "priority": 0, "tag": "a7e6fb77503c41d8a7f3113c6918f10c" } } ``` ## Update routing rule `client.EmailRouting.Rules.Update(ctx, ruleIdentifier, params) (*EmailRoutingRule, error)` **put** `/zones/{zone_id}/email/routing/rules/{rule_identifier}` Update actions and matches, or enable/disable specific routing rules. ### Parameters - `ruleIdentifier string` Routing rule identifier. - `params RuleUpdateParams` - `ZoneID param.Field[string]` Path param: Identifier. - `Actions param.Field[[]Action]` Body param: List actions patterns. - `Type ActionType` Type of supported action. - `const ActionTypeDrop ActionType = "drop"` - `const ActionTypeForward ActionType = "forward"` - `const ActionTypeWorker ActionType = "worker"` - `Value []string` - `Matchers param.Field[[]Matcher]` Body param: Matching patterns to forward to your actions. - `Type MatcherType` Type of matcher. - `const MatcherTypeAll MatcherType = "all"` - `const MatcherTypeLiteral MatcherType = "literal"` - `Field MatcherField` Field for type matcher. - `const MatcherFieldTo MatcherField = "to"` - `Value string` Value for matcher. - `Enabled param.Field[RuleUpdateParamsEnabled]` Body param: Routing rule status. - `const RuleUpdateParamsEnabledTrue RuleUpdateParamsEnabled = true` - `const RuleUpdateParamsEnabledFalse RuleUpdateParamsEnabled = false` - `Name param.Field[string]` Body param: Routing rule name. - `Priority param.Field[float64]` Body param: Priority of the routing rule. ### Returns - `type EmailRoutingRule struct{…}` - `ID string` Routing rule identifier. - `Actions []Action` List actions patterns. - `Type ActionType` Type of supported action. - `const ActionTypeDrop ActionType = "drop"` - `const ActionTypeForward ActionType = "forward"` - `const ActionTypeWorker ActionType = "worker"` - `Value []string` - `Enabled EmailRoutingRuleEnabled` Routing rule status. - `const EmailRoutingRuleEnabledTrue EmailRoutingRuleEnabled = true` - `const EmailRoutingRuleEnabledFalse EmailRoutingRuleEnabled = false` - `Matchers []Matcher` Matching patterns to forward to your actions. - `Type MatcherType` Type of matcher. - `const MatcherTypeAll MatcherType = "all"` - `const MatcherTypeLiteral MatcherType = "literal"` - `Field MatcherField` Field for type matcher. - `const MatcherFieldTo MatcherField = "to"` - `Value string` Value for matcher. - `Name string` Routing rule name. - `Priority float64` Priority of the routing rule. - `Tag string` Routing rule tag. (Deprecated, replaced by routing rule identifier) ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/email_routing" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"), option.WithAPIEmail("user@example.com"), ) emailRoutingRule, err := client.EmailRouting.Rules.Update( context.TODO(), "a7e6fb77503c41d8a7f3113c6918f10c", email_routing.RuleUpdateParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), Actions: cloudflare.F([]email_routing.ActionParam{email_routing.ActionParam{ Type: cloudflare.F(email_routing.ActionTypeForward), }}), Matchers: cloudflare.F([]email_routing.MatcherParam{email_routing.MatcherParam{ Type: cloudflare.F(email_routing.MatcherTypeLiteral), }}), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", emailRoutingRule.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "a7e6fb77503c41d8a7f3113c6918f10c", "actions": [ { "type": "forward", "value": [ "destinationaddress@example.net" ] } ], "enabled": true, "matchers": [ { "type": "literal", "field": "to", "value": "test@example.com" } ], "name": "Send to user@example.net rule.", "priority": 0, "tag": "a7e6fb77503c41d8a7f3113c6918f10c" } } ``` ## Delete routing rule `client.EmailRouting.Rules.Delete(ctx, ruleIdentifier, body) (*EmailRoutingRule, error)` **delete** `/zones/{zone_id}/email/routing/rules/{rule_identifier}` Delete a specific routing rule. ### Parameters - `ruleIdentifier string` Routing rule identifier. - `body RuleDeleteParams` - `ZoneID param.Field[string]` Identifier. ### Returns - `type EmailRoutingRule struct{…}` - `ID string` Routing rule identifier. - `Actions []Action` List actions patterns. - `Type ActionType` Type of supported action. - `const ActionTypeDrop ActionType = "drop"` - `const ActionTypeForward ActionType = "forward"` - `const ActionTypeWorker ActionType = "worker"` - `Value []string` - `Enabled EmailRoutingRuleEnabled` Routing rule status. - `const EmailRoutingRuleEnabledTrue EmailRoutingRuleEnabled = true` - `const EmailRoutingRuleEnabledFalse EmailRoutingRuleEnabled = false` - `Matchers []Matcher` Matching patterns to forward to your actions. - `Type MatcherType` Type of matcher. - `const MatcherTypeAll MatcherType = "all"` - `const MatcherTypeLiteral MatcherType = "literal"` - `Field MatcherField` Field for type matcher. - `const MatcherFieldTo MatcherField = "to"` - `Value string` Value for matcher. - `Name string` Routing rule name. - `Priority float64` Priority of the routing rule. - `Tag string` Routing rule tag. (Deprecated, replaced by routing rule identifier) ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/email_routing" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"), option.WithAPIEmail("user@example.com"), ) emailRoutingRule, err := client.EmailRouting.Rules.Delete( context.TODO(), "a7e6fb77503c41d8a7f3113c6918f10c", email_routing.RuleDeleteParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", emailRoutingRule.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "a7e6fb77503c41d8a7f3113c6918f10c", "actions": [ { "type": "forward", "value": [ "destinationaddress@example.net" ] } ], "enabled": true, "matchers": [ { "type": "literal", "field": "to", "value": "test@example.com" } ], "name": "Send to user@example.net rule.", "priority": 0, "tag": "a7e6fb77503c41d8a7f3113c6918f10c" } } ``` ## Domain Types ### Action - `type Action struct{…}` Actions pattern. - `Type ActionType` Type of supported action. - `const ActionTypeDrop ActionType = "drop"` - `const ActionTypeForward ActionType = "forward"` - `const ActionTypeWorker ActionType = "worker"` - `Value []string` ### Email Routing Rule - `type EmailRoutingRule struct{…}` - `ID string` Routing rule identifier. - `Actions []Action` List actions patterns. - `Type ActionType` Type of supported action. - `const ActionTypeDrop ActionType = "drop"` - `const ActionTypeForward ActionType = "forward"` - `const ActionTypeWorker ActionType = "worker"` - `Value []string` - `Enabled EmailRoutingRuleEnabled` Routing rule status. - `const EmailRoutingRuleEnabledTrue EmailRoutingRuleEnabled = true` - `const EmailRoutingRuleEnabledFalse EmailRoutingRuleEnabled = false` - `Matchers []Matcher` Matching patterns to forward to your actions. - `Type MatcherType` Type of matcher. - `const MatcherTypeAll MatcherType = "all"` - `const MatcherTypeLiteral MatcherType = "literal"` - `Field MatcherField` Field for type matcher. - `const MatcherFieldTo MatcherField = "to"` - `Value string` Value for matcher. - `Name string` Routing rule name. - `Priority float64` Priority of the routing rule. - `Tag string` Routing rule tag. (Deprecated, replaced by routing rule identifier) ### Matcher - `type Matcher struct{…}` Matching pattern to forward your actions. - `Type MatcherType` Type of matcher. - `const MatcherTypeAll MatcherType = "all"` - `const MatcherTypeLiteral MatcherType = "literal"` - `Field MatcherField` Field for type matcher. - `const MatcherFieldTo MatcherField = "to"` - `Value string` Value for matcher. # Catch Alls ## Get catch-all rule `client.EmailRouting.Rules.CatchAlls.Get(ctx, query) (*RuleCatchAllGetResponse, error)` **get** `/zones/{zone_id}/email/routing/rules/catch_all` Get information on the default catch-all routing rule. ### Parameters - `query RuleCatchAllGetParams` - `ZoneID param.Field[string]` Identifier. ### Returns - `type RuleCatchAllGetResponse struct{…}` - `ID string` Routing rule identifier. - `Actions []CatchAllAction` List actions for the catch-all routing rule. - `Type CatchAllActionType` Type of action for catch-all rule. - `const CatchAllActionTypeDrop CatchAllActionType = "drop"` - `const CatchAllActionTypeForward CatchAllActionType = "forward"` - `const CatchAllActionTypeWorker CatchAllActionType = "worker"` - `Value []string` - `Enabled RuleCatchAllGetResponseEnabled` Routing rule status. - `const RuleCatchAllGetResponseEnabledTrue RuleCatchAllGetResponseEnabled = true` - `const RuleCatchAllGetResponseEnabledFalse RuleCatchAllGetResponseEnabled = false` - `Matchers []CatchAllMatcher` List of matchers for the catch-all routing rule. - `Type CatchAllMatcherType` Type of matcher. Default is 'all'. - `const CatchAllMatcherTypeAll CatchAllMatcherType = "all"` - `Name string` Routing rule name. - `Tag string` Routing rule tag. (Deprecated, replaced by routing rule identifier) ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/email_routing" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"), option.WithAPIEmail("user@example.com"), ) catchAll, err := client.EmailRouting.Rules.CatchAlls.Get(context.TODO(), email_routing.RuleCatchAllGetParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", catchAll.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "a7e6fb77503c41d8a7f3113c6918f10c", "actions": [ { "type": "forward", "value": [ "destinationaddress@example.net" ] } ], "enabled": true, "matchers": [ { "type": "all" } ], "name": "Send to user@example.net rule.", "tag": "a7e6fb77503c41d8a7f3113c6918f10c" } } ``` ## Update catch-all rule `client.EmailRouting.Rules.CatchAlls.Update(ctx, params) (*RuleCatchAllUpdateResponse, error)` **put** `/zones/{zone_id}/email/routing/rules/catch_all` Enable or disable catch-all routing rule, or change action to forward to specific destination address. ### Parameters - `params RuleCatchAllUpdateParams` - `ZoneID param.Field[string]` Path param: Identifier. - `Actions param.Field[[]CatchAllAction]` Body param: List actions for the catch-all routing rule. - `Type CatchAllActionType` Type of action for catch-all rule. - `const CatchAllActionTypeDrop CatchAllActionType = "drop"` - `const CatchAllActionTypeForward CatchAllActionType = "forward"` - `const CatchAllActionTypeWorker CatchAllActionType = "worker"` - `Value []string` - `Matchers param.Field[[]CatchAllMatcher]` Body param: List of matchers for the catch-all routing rule. - `Type CatchAllMatcherType` Type of matcher. Default is 'all'. - `const CatchAllMatcherTypeAll CatchAllMatcherType = "all"` - `Enabled param.Field[RuleCatchAllUpdateParamsEnabled]` Body param: Routing rule status. - `const RuleCatchAllUpdateParamsEnabledTrue RuleCatchAllUpdateParamsEnabled = true` - `const RuleCatchAllUpdateParamsEnabledFalse RuleCatchAllUpdateParamsEnabled = false` - `Name param.Field[string]` Body param: Routing rule name. ### Returns - `type RuleCatchAllUpdateResponse struct{…}` - `ID string` Routing rule identifier. - `Actions []CatchAllAction` List actions for the catch-all routing rule. - `Type CatchAllActionType` Type of action for catch-all rule. - `const CatchAllActionTypeDrop CatchAllActionType = "drop"` - `const CatchAllActionTypeForward CatchAllActionType = "forward"` - `const CatchAllActionTypeWorker CatchAllActionType = "worker"` - `Value []string` - `Enabled RuleCatchAllUpdateResponseEnabled` Routing rule status. - `const RuleCatchAllUpdateResponseEnabledTrue RuleCatchAllUpdateResponseEnabled = true` - `const RuleCatchAllUpdateResponseEnabledFalse RuleCatchAllUpdateResponseEnabled = false` - `Matchers []CatchAllMatcher` List of matchers for the catch-all routing rule. - `Type CatchAllMatcherType` Type of matcher. Default is 'all'. - `const CatchAllMatcherTypeAll CatchAllMatcherType = "all"` - `Name string` Routing rule name. - `Tag string` Routing rule tag. (Deprecated, replaced by routing rule identifier) ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/email_routing" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"), option.WithAPIEmail("user@example.com"), ) catchAll, err := client.EmailRouting.Rules.CatchAlls.Update(context.TODO(), email_routing.RuleCatchAllUpdateParams{ ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), Actions: cloudflare.F([]email_routing.CatchAllActionParam{email_routing.CatchAllActionParam{ Type: cloudflare.F(email_routing.CatchAllActionTypeForward), }}), Matchers: cloudflare.F([]email_routing.CatchAllMatcherParam{email_routing.CatchAllMatcherParam{ Type: cloudflare.F(email_routing.CatchAllMatcherTypeAll), }}), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", catchAll.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "id": "a7e6fb77503c41d8a7f3113c6918f10c", "actions": [ { "type": "forward", "value": [ "destinationaddress@example.net" ] } ], "enabled": true, "matchers": [ { "type": "all" } ], "name": "Send to user@example.net rule.", "tag": "a7e6fb77503c41d8a7f3113c6918f10c" } } ``` ## Domain Types ### Catch All Action - `type CatchAllAction struct{…}` Action for the catch-all routing rule. - `Type CatchAllActionType` Type of action for catch-all rule. - `const CatchAllActionTypeDrop CatchAllActionType = "drop"` - `const CatchAllActionTypeForward CatchAllActionType = "forward"` - `const CatchAllActionTypeWorker CatchAllActionType = "worker"` - `Value []string` ### Catch All Matcher - `type CatchAllMatcher struct{…}` Matcher for catch-all routing rule. - `Type CatchAllMatcherType` Type of matcher. Default is 'all'. - `const CatchAllMatcherTypeAll CatchAllMatcherType = "all"`